package com.liangjian.dataplatform.member.entity.po.elasticsearch;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;


/**
 * @author 黄树文
 * @date 2020/3/10 9:33
 */
@Data
@Accessors(chain = true)
@Document(indexName = "areadata", type = "_doc")
@JsonIgnoreProperties(ignoreUnknown=true)
public class AreaData {
    @Id
    protected Long id;

    @Field(name = "AreaName", type = FieldType.Text, analyzer = "ik_max_word")
    @JsonProperty("AreaName")
    protected String AreaName;

    @Field(name = "ParentAreaName", type = FieldType.Text, analyzer = "ik_max_word")
    @JsonProperty("ParentAreaName")
    protected String ParentAreaName;

    @Field(name = "Level")
    @JsonProperty("Level")
    protected Integer Level;

    @Field(name = "ParentLevel")
    @JsonProperty("ParentLevel")
    protected Integer ParentLevel;

    @Field(name = "RelateID")
    @JsonProperty("RelateID")
    protected Integer RelateID;

    @Field(name = "ParentMappingCode")
    @JsonProperty("ParentMappingCode")
    protected Integer ParentMappingCode;

    @Field(name = "MappingCode")
    @JsonProperty("MappingCode")
    protected Integer MappingCode;


}
