package com.liangjian.dataplatform.member.entity.po.primary;

import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import java.io.Serializable;

@Entity(name = "platform_object_tagstore")
public class PlatformObjectTagStore implements Serializable {

    private static long serialVersionUID = 6765100397603094219L;

    @Id
    @GeneratedValue(generator = "metaRelGenerator")
    @GenericGenerator(name = "metaRelGenerator", strategy = "com.liangjian.dataplatform.member.entity.genernator.SnowflakeGenernatorLong")
    private Long id;

    @Column(name = "object_id")
    private Long objectId;

    @Column(name = "object_code")
    private String objectCode;

    @Column(name = "tag_code")
    private String tagCode;

    @Column(name = "tag_name")
    private String tagName;

    @Column(name = "tag_source")
    private String tagSource;

    @Column(name = "tag_field_type")
    private String tagFieldType;

    @Column(name = "parent_ids")
    private String parentIds;

    @Column(name = "parent_codes")
    private String parentCodes;

    @Column(name = "parent_names")
    private String parentNames;

    @Column(name = "rank")
    private Byte rank;

    @Column(name = "state")
    private Byte state;

    @Column(name = "use_number")
    private Integer useNumber;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public static void setSerialVersionUID(long serialVersionUID) {
        PlatformObjectTagStore.serialVersionUID = serialVersionUID;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getObjectId() {
        return objectId;
    }

    public void setObjectId(Long objectId) {
        this.objectId = objectId;
    }

    public String getObjectCode() {
        return objectCode;
    }

    public void setObjectCode(String objectCode) {
        this.objectCode = objectCode;
    }

    public String getTagCode() {
        return tagCode;
    }

    public void setTagCode(String tagCode) {
        this.tagCode = tagCode;
    }

    public String getTagName() {
        return tagName;
    }

    public void setTagName(String tagName) {
        this.tagName = tagName;
    }

    public String getTagSource() {
        return tagSource;
    }

    public void setTagSource(String tagSource) {
        this.tagSource = tagSource;
    }

    public String getTagFieldType() {
        return tagFieldType;
    }

    public void setTagFieldType(String tagFieldType) {
        this.tagFieldType = tagFieldType;
    }

    public String getParentIds() {
        return parentIds;
    }

    public void setParentIds(String parentIds) {
        this.parentIds = parentIds;
    }

    public String getParentCodes() {
        return parentCodes;
    }

    public void setParentCodes(String parentCodes) {
        this.parentCodes = parentCodes;
    }

    public String getParentNames() {
        return parentNames;
    }

    public void setParentNames(String parentNames) {
        this.parentNames = parentNames;
    }

    public Byte getRank() {
        return rank;
    }

    public void setRank(Byte rank) {
        this.rank = rank;
    }

    public Byte getState() {
        return state;
    }

    public void setState(Byte state) {
        this.state = state;
    }

    public Integer getUseNumber() {
        return useNumber;
    }

    public void setUseNumber(Integer useNumber) {
        this.useNumber = useNumber;
    }
}
