package com.liangjian.dataplatform.member.controller;

import com.liangjian.dataplatform.member.entity.po.secondary.FiltersData;
import com.liangjian.dataplatform.member.entity.po.secondary.MemberDataFilter;
import com.liangjian.dataplatform.member.entity.vo.response.BirdGirdTableResponse2;
import com.liangjian.dataplatform.member.service.IMemberListService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;

@RestController
@RequestMapping("/memberList")
@Api(value = "会员列表控制器", tags = "会员列表控", description = "会员列表控制器")
public class MemberListController {

    @Autowired
    private IMemberListService memberListService;


    @PostMapping("/index")
    @ApiOperation(value = "查询会员列表")
    public String index(@ApiParam(value = "参数", required = true) @RequestBody FiltersData data) {
        System.out.println(data);
        return memberListService.index(data);
    }


    @PostMapping("/getMemberList")
    @ApiOperation(value = "根据条件查询会员列表")
    public BirdGirdTableResponse2 getMemberList(@ApiParam(value = "参数", required = true) @RequestBody MemberDataFilter data) throws IOException {
        MemberDataFilter memberDataFilter = new MemberDataFilter();
        System.out.println(memberDataFilter);
        System.out.println(data);
        return memberListService.getMemberList(data);
    }

}
