package com.liangjian.dataplatform.member.controller;

import com.liangjian.dataplatform.member.entity.po.secondary.FiltersData;
import com.liangjian.dataplatform.member.service.IMrugTakeInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@RequestMapping("/mrugTakeInfo")
@Api(value = "药品使用详情控制器", tags = "药品使用详情控制器", description = "药品使用详情控制器")
public class MrugTakeInfoController {

    @Autowired
    private IMrugTakeInfoService mrugTakeInfoService;


    @PostMapping("/getProductUsageList")
    @ApiOperation(value = "获取药品说明信息")
    public Map<String, Object> getProductUsageList(@ApiParam(value = "参数", required = true) @RequestBody FiltersData data) {

        return mrugTakeInfoService.getProductUsageList(data);
    }

    @PostMapping("/updateTakeInfo")
    @ApiOperation(value = "修改药品说明")
    public Map<String, Object> updateTakeInfo(@ApiParam(value = "参数", required = true) @RequestBody Map<String, Object> data) {

        return mrugTakeInfoService.updateTakeInfo(data);
    }


}
