package com.liangjian.dataplatform.member.service;

import com.liangjian.dataplatform.member.entity.vo.request.BirdGirdRequest;
import com.liangjian.dataplatform.member.entity.vo.response.BirdGirdTableResponse;
import com.liangjian.dataplatform.member.safe.Tuple;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @Author: 黄子奇
 * @Date: 2019/11/4
 */
public interface IBirdGirdService {

    /**
     * 包装sql查询并分页
     *
     * @param dsId
     * @param sqlId
     * @param birdGirdRequest
     * @return
     */
    BirdGirdTableResponse readSql(String dsId, String sqlId, BirdGirdRequest birdGirdRequest);

    /**
     * 包装sql查询不分页
     *
     * @param dsId
     * @param sqlId
     * @param birdGirdRequest
     * @return
     */
    Tuple<String, BirdGirdTableResponse> readSqlUnpaged(String dsId, String sqlId, BirdGirdRequest birdGirdRequest);
}
